<?php
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_title' => '<h4>',
        'after_title' => '</h4>',
    ));

add_filter('comments_template', 'legacycomments');
function legacycomments() {
  if (!function_exists('wp_list_comments') || !get_option('thread_comments')) {
    return TEMPLATEPATH.'/legacycomments.php'; }
}

function kaleidoscope_comments($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?>
      <div id="div-comment-<?php comment_ID(); ?>">  
        <div id="singlecomment" class="<?php if ($comment->user_id == $post->post_author) {echo "postauthor";} else {echo "other";}?>">
        		<div class="commentmeta">
              <span class="thenumber">
                <?php 
                $valid_email = $comment->comment_author_email;
                      echo $avatar_results = get_avatar($valid_email, $size='16');
                ?>
              </span>
              <span class="thecitation"><span class="commentcite"><cite><?php comment_author_link() ?></cite> said:</span>&nbsp;<?php edit_comment_link('(edit)','&nbsp;',''); ?></span>
              <span class="thedate"><a href="#comment-<?php comment_ID() ?>" title="Permalink to this comment"><?php comment_date('m/d/y') ?></a></span>
            </div>                
              
              <?php if ($comment->comment_approved == '0') : ?>
        			<p><em>Your comment is awaiting moderation.</em></p>
        			<?php endif; ?>         
            <div class="reply"><?php comment_reply_link(array_merge( $args, array('add_below' => 'div-comment', 'depth' => $depth, 'max_depth' => $args['max_depth']))) ?></div>
            <div class="commentcontent"><?php comment_text(); ?></div>
            
        </div>
      </div>  
<?php }

function length_fix($x){
    if(strlen($x)<2){
        $x = sprintf("0%s",$x);
    }
    return $x;
}

function cos_color ($pshift) {
  // the color's value
  $hbase=.82; //$hbase 0<$hsafe<2; ~2 bright/white, ~0 dark/black
  
  // the colors saturation
  global $postyear;
  $yeardiff = date(Y)-$postyear;  // $hshift 1-->0
  $hshift = .08*$yeardiff;          // $hshift is how much to change tint/shade /yr
  
  if ($hshift > 1) { //this assures that the colors are always valid (after years of darkening)
    $hshift = 1;
  }
  
  if ($hbase > 1) {     // assuring $hsafe is always <= 1, so that wave peaks are still less than 255 
    $hsafe = 2-$hbase;  // $hsafe assures that all colors will be valid 
  }
  if ($hbase <= 1) {  //when we don't seen to worry about height
    $hsafe = $hbase;
  }
   
  // change the first (and only the first) +/- to toggle fade/darken
  $coscol = dechex(127.5*(($hbase-($hsafe*$hshift))+(($hsafe-($hsafe*$hshift))*(cos((M_PI*($pshift))/180)))));
  return $coscol;
}

function broaden_shift($indeg, $broaden=0, $shift=0) { //$range is roughly the length you want to spend on the peak
  //$newx = $x;  // it's best to avoid values for $range above 75, the curves get wonky
  $outdeg = $shift+$indeg-($broaden*sin((M_PI*($indeg+$shift))/180));
  return $outdeg;
}

function date_to_color($day,$year) {
  global $postyear;
  $postyear = $year;

  $degrees = .986*$day; // beacuse there are 360, not 365.24, degrees in a circle
  if (get_option(southern_hemisphere)) {$degrees = $degrees+180;}
  $redshift = broaden_shift($degrees, 18, 134); //Best Values: 18, 134
  $greenshift = broaden_shift($degrees, 20, 240);//Best Values: 20, 240
  $blueshift = broaden_shift($degrees, 10); //5, 0
  $redhex = cos_color($redshift);
  $greenhex = cos_color($greenshift);
  $bluehex = cos_color($blueshift);
  $redfix = length_fix($redhex);
  $greenfix = length_fix($greenhex);
  $bluefix = length_fix($bluehex);
  
  $bestrgb = sprintf("%s%s%s",$redfix,$greenfix,$bluefix);
  return $bestrgb;
}

function is_valid_gravatar($email,$default='identicon',$redirect = 1) {
	$emailhash = md5($email);
	$uri = 'http://www.gravatar.com/avatar/'.$emailhash;
	$uri .= '?d='.urlencode($default).'&r=any&size=80';

	$headers = wp_get_http_headers($uri,$redirect);

	if (isset($headers["content-disposition"])) {
      return $uri;
	} 
  else {		
    return false;
	} 
}

function mini_quilt () { ?>
    <li><h4>The Mini Quilt</h4>
    	  <ul class="miniquiltbox">
        <?php
            $recentPosts = new WP_Query();
            $recentPosts->query('showposts=35&caller_get_posts=1');
        ?>
        <?php while ($recentPosts->have_posts()) : $recentPosts->the_post(); ?>
          <li><a style="background-color: #<?php echo date_to_color(get_the_time(z), get_the_time(Y)); ?>;" href="<?php the_permalink() ?>" rel="bookmark" title="Permalink to '<?php the_title(); ?>'"></a></li>
      	<?php endwhile; ?>
      	</ul>
    </li>
<?php }

register_sidebar_widget('Kaleidoscope Mini Quilt','mini_quilt');

function kaleidoscope_search() { ?>
		<li><h4>Search</h4>
			<?php include (TEMPLATEPATH . '/searchform.php'); ?>
		</li>
<?php }

register_sidebar_widget('Search', 'kaleidoscope_search');
//The function below is a trimmed version of Matt Mullenweg's Random Redirect Plugin
function matt_random_redirect() {
	global $wpdb;
	$query = "SELECT ID FROM $wpdb->posts WHERE post_type = 'post' AND post_password = '' AND 	post_status = 'publish' ORDER BY RAND() LIMIT 1";

	$random_id = $wpdb->get_var( $query );
	wp_redirect( get_permalink( $random_id ) );
	exit;
}
if ( isset( $_GET['random'] ) )
	add_action( 'template_redirect', 'matt_random_redirect' );
	
function sc_safe_random() { /*a simplified version of the above function that, because it doens't need a redirect, is safe from WP Super Cache*/
	global $wpdb;
	$query = "SELECT ID FROM $wpdb->posts WHERE post_type = 'post' AND post_password = '' AND 	post_status = 'publish' ORDER BY RAND() LIMIT 1";
	$random_id = $wpdb->get_var( $query );
	return get_permalink($random_id);
}



// THIS IS modified FROM http://theundersigned.net/wp-content/optionspage/functions.phps
$options = array (
    
    array(  "name" => "Accent Color",
            "id" => "accent_color",
            "std" => "#888888",
            "type" => "text",
            "desc" => "This is used to color the description in the header and the links in the footer."),
    
/*    array(  "name" => "Body font",
            "id" => "_body_font",
            "type" => "select",
            "std" => "Arial",
            "options" => array("Verdana", "Arial", "Georgia")),
*/            
    array(  "name" => "Gravatars",
            "id" => "show_default_gravatars",
            "type" => "radio",
            "std" => FALSE,
            "values" => array(FALSE, TRUE),
            "options" => array("Replace the default gravatars with comment number", "Show default gravatars"),
            "desc" => "In the comments section of a post, Kaleidoscope replaces default gravatars with the number of that comment. Toggle this to change that behavior. (Only for users who haven't enabled threaded comments.)"),

    array(  "name" => "Mini Quilt in Sidebar",
            "id" => "hide_mini_quilt",
            "type" => "radio",
            "std" => FALSE,
            "values" => array(FALSE, TRUE),
            "options" => array("Show the Mini Quilt in the sidebar", "Show seven Latest Entries"),
            "desc" => "The Mini Quilt shows 35 recent posts, with the titles shown only on mousover. If you don't like that, you can get a list of seven recent post. Of course, you can make greater changes to the sidebar by using widgets."), 
    
    array(  "name" => "Southern Hemisphere",
            "id" => "southern_hemisphere",
            "type" => "radio",
            "std" => FALSE,
            "values" => array(FALSE, TRUE),
            "options" => array("Give me Northern Hemisphere colors", "I want Southern seasons"),
            "desc" => "This shifts things by six months. It makes winter into summer, etc. But unfortunately, only in the colors on your blog."),
            
);

function mytheme_add_admin() {

    global $options;

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                  if ($value['type'] == check) {
                  for($x = 0; $x < count($value['options']); $x++) {
                    update_option( $value['values'][$x], $_REQUEST[ $value['values'][$x] ] ); }
                  }
                  else {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
                  }
                  
                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } elseif ( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); }

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page("Kaleidoscope Options", "Kaleidoscope Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

    global $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>Your settings have been saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>Your settings have been reset.</strong></p></div>';
    
?>
<div class="wrap">
<h2>Kaleidoscope Settings</h2>

<form method="post">
<table class="form-table">

<?php foreach ($options as $value) { 
    
if ($value['type'] == "text") { ?>
        
<tr> 
    <th><h4><label for="<?php echo $value['id']; ?>""><?php echo $value['name']; ?>:</label></h4></th>
    <td>
        <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo get_option( $value['id'] ); } else { echo $value['std']; } ?>" />
    </td>
    <td><?php echo $value['desc']?></td>
</tr>

<?php } elseif ($value['type'] == "select") { ?>

    <tr> 
        <th><h4><label for="<?php echo $value['id']; ?>""><?php echo $value['name']; ?>:</label></h4></th>
        <td>
            <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
                <?php foreach ($value['options'] as $option) { ?>
                <option<?php if ( get_option( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
                <?php } ?>
            </select>
        </td>
        <td><?php echo $value['desc']?></td>
    </tr>

<?php } elseif ($value['type'] == "radio") { ?>

    <tr> 
        <th width="17%"><h4><?php echo $value['name']; ?>:</h4></th>
        <td width="38%">
          <?php for($x = 0; $x < count($value['options']); $x++) { ?>
          <input name="<?php echo $value['id']; ?>" 
                  id="<?php echo $value['id']; ?>_<?php echo $value['values'][$x]?>" 
                  type="radio" 
                  value="<?php echo $value['values'][$x]?>" 
                  <?php if (get_option($value['id'])!=0 && get_option($value['id']) == $value['values'][$x]) {echo checked;}
                  elseif ($value['std'] == $value['values'][$x]) {echo checked; } ?>>
                  <label for="<?php echo $value['id']; ?>_<?php echo $value['values'][$x]; ?>""><?php echo $value['options'][$x]?></label>
                  <br />
          <?php } ?>
        </td>
        <td width="45%"><p><?php echo $value['desc']?></p></td>
    </tr>
<?php } elseif ($value['type'] == "check") { ?>

    <tr> 
        <th width="17%"><h4><?php echo $value['name']; ?>:</h4></th>
        <td width="38%">
          <?php for($x = 0; $x < count($value['options']); $x++) { ?>
          <input name="<?php echo $value['id']?>" 
                  id="<?php echo $value['id']?>_<?php echo $x ?>" 
                  type="checkbox" 
                  value="<?php echo $value['values'][$x]?>" 
                  <?php if ( get_option($value['values'][$x]) == $value['values'][$x] ) {echo 'checked="checked"';} ?>>
                  <label for="<?php echo $value['values'][$x]?>"><?php echo $value['options'][$x]?></label>
                  <br />
          <?php } ?>
        </td>
        <td width="45%"><p><?php echo $value['desc']?></p></td>
    </tr>
<?php 
} 
}
?>

</table>
<p class="submit">
<input name="save" type="submit" value="Save changes" />    
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<?php
}

add_action('admin_menu', 'mytheme_add_admin'); ?>
